import { renderless, api } from '@opentinyvue/vue-renderless/selected-box/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import { IconClose } from '@opentinyvue/vue-icon';
import Popover from '@opentinyvue/vue-popover';
import { resolveComponent, openBlock, createElementBlock, createElementVNode, renderSlot, toDisplayString, createCommentVNode, normalizeClass, Fragment, renderList, createVNode } from 'vue';

function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
    t && (r = t);
    var o = 0;
    return function() {
      return o >= r.length ? { done: true } : { done: false, value: r[o++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  emits: ["change", "clear", "delete", "drag"],
  props: [].concat(props, ["inverse", "total", "select", "config"]),
  components: {
    IconClose: IconClose(),
    TinyPopover: Popover
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  "data-tag": "tiny-selected-box",
  class: "h-full mx-2 grid grid-cols-1 grid-rows-[theme(spacing.9)_auto] bg-color-bg-1"
};
var _hoisted_2 = {
  "data-tag": "tiny-selected-box-content",
  class: "flex justify-between items-center text-xs text-color-text-primary px-2"
};
var _hoisted_3 = {
  "data-tag": "tiny-selected-box-select",
  class: "max-w-[theme(spacing.32)]"
};
var _hoisted_4 = {
  class: "cursor-pointer"
};
var _hoisted_5 = {
  "data-tag": "tiny-selected-box-clear",
  class: "flex space-x-2 select-none text-color-brand"
};
var _hoisted_6 = ["data-key"];
var _hoisted_7 = {
  class: "grid grid-cols-[auto_theme(spacing.6)]",
  "data-tag": "tiny-selected-box-option"
};
var _hoisted_8 = {
  class: "truncate",
  "data-tag": "tiny-selected-box-truncate"
};
var _hoisted_9 = {
  class: "h-7 truncate translate-y-1"
};
var _hoisted_10 = {
  key: 0,
  class: "h-7 truncate -translate-y-1"
};
var _hoisted_11 = {
  "data-tag": "tiny-selected-box-close"
};
var _hoisted_12 = {
  "data-tag": "tiny-selected-box-icon",
  class: /* @__PURE__ */ normalizeClass(["h-7 translate-y-1 flex items-center justify-end", "fill-color-icon-primary hover:fill-color-icon-hover"])
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_close = resolveComponent("icon-close");
  var _component_tiny_popover = resolveComponent("tiny-popover");
  return openBlock(), createElementBlock("div", _hoisted_1, [createElementVNode("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [renderSlot(_ctx.$slots, "select", {
    params: _ctx.state.slotParams
  }, function() {
    return [createElementVNode(
      "span",
      _hoisted_4,
      toDisplayString(_ctx.i18nSelected()),
      1
      /* TEXT */
    )];
  })]), createElementVNode("div", _hoisted_5, [renderSlot(_ctx.$slots, "button", {
    params: _ctx.state.slotParams
  }), renderSlot(_ctx.$slots, "clear", {
    params: _ctx.state.slotParams,
    clear: _ctx.handleClear
  }, function() {
    return [_ctx.state.showClear ? (openBlock(), createElementBlock(
      "div",
      {
        key: 0,
        class: "cursor-pointer",
        onClick: _cache[0] || (_cache[0] = function() {
          return _ctx.handleClear && _ctx.handleClear.apply(_ctx, arguments);
        })
      },
      toDisplayString(_ctx.t("ui.selectedBox.clear")),
      1
      /* TEXT */
    )) : createCommentVNode("v-if", true)];
  })])]), createElementVNode(
    "div",
    {
      "data-tag": "tiny-selected-box-list",
      ref: "list",
      class: normalizeClass(["overflow-x-hidden overflow-y-auto text-xs text-color-text-primary", {
        "line-through decoration-solid decoration-color-text-primary": _ctx.state.inverse
      }])
    },
    [(openBlock(true), createElementBlock(
      Fragment,
      null,
      renderList(_ctx.state.select, function(option, i) {
        return openBlock(), createElementBlock("div", {
          key: "o" + i + "-" + _ctx.state.refresh,
          "data-key": _ctx.keyOption(option),
          "data-tag": "tiny-selected-box-item",
          class: "cursor-pointer hover:bg-color-bg-2 px-2 rounded-sm"
        }, [createElementVNode("div", _hoisted_7, [createElementVNode("div", _hoisted_8, [renderSlot(_ctx.$slots, "option", {
          params: _ctx.state.slotParams,
          option,
          mouseenter: _ctx.handleMouseenter,
          mouseleave: _ctx.handleMouseleave
        }, function() {
          return [createElementVNode("div", _hoisted_9, [createElementVNode(
            "div",
            {
              class: "truncate relative top-1/2 -translate-y-1/2",
              onMouseenter: _cache[1] || (_cache[1] = function() {
                return _ctx.handleMouseenter && _ctx.handleMouseenter.apply(_ctx, arguments);
              }),
              onMouseleave: _cache[2] || (_cache[2] = function() {
                return _ctx.handleMouseleave && _ctx.handleMouseleave.apply(_ctx, arguments);
              })
            },
            toDisplayString(_ctx.textPrimary(option)),
            33
            /* TEXT, NEED_HYDRATION */
          )]), _ctx.state.showAuxi ? (openBlock(), createElementBlock("div", _hoisted_10, [createElementVNode(
            "div",
            {
              class: "truncate text-color-text-placeholder relative top-1/2 -translate-y-1/2",
              onMouseenter: _cache[3] || (_cache[3] = function() {
                return _ctx.handleMouseenter && _ctx.handleMouseenter.apply(_ctx, arguments);
              }),
              onMouseleave: _cache[4] || (_cache[4] = function() {
                return _ctx.handleMouseleave && _ctx.handleMouseleave.apply(_ctx, arguments);
              })
            },
            toDisplayString(_ctx.textAuxi(option)),
            33
            /* TEXT, NEED_HYDRATION */
          )])) : createCommentVNode("v-if", true)];
        })]), createElementVNode("div", _hoisted_11, [renderSlot(_ctx.$slots, "close", {
          params: _ctx.state.slotParams,
          option,
          close: _ctx.handleDelete
        }, function() {
          return [createElementVNode("div", _hoisted_12, [createVNode(_component_icon_close, {
            onClick: function onClick($event) {
              return _ctx.handleDelete(option);
            }
          }, null, 8, ["onClick"])])];
        })])])], 8, _hoisted_6);
      }),
      128
      /* KEYED_FRAGMENT */
    ))],
    2
    /* CLASS */
  ), createVNode(_component_tiny_popover, {
    ref: "popover",
    trigger: "manual",
    class: "hidden",
    content: _ctx.state.popoverContent,
    modelValue: _ctx.state.popoverVisible,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function($event) {
      return _ctx.state.popoverVisible = $event;
    })
  }, null, 8, ["content", "modelValue"])]);
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);

export { mobileFirst as default };
